// GM Arts interface for TB-12 relays

#include <avr/io.h>
#include <inttypes.h>
#include "relays.h"

const ioRelayRegs RelayRegs[4] = {
  {&RELAY_1_DDR, &RELAY_1_PORT, RELAY_1_PIN},
  {&RELAY_2_DDR, &RELAY_2_PORT, RELAY_2_PIN},
  {&RELAY_3_DDR, &RELAY_3_PORT, RELAY_3_PIN},
  {&RELAY_4_DDR, &RELAY_4_PORT, RELAY_4_PIN}};

void InitRelays()
{
  // set relay port pins to outputs
  uint8_t i;
  for (i = 0; i < 4; ++i) {
    (*(RelayRegs[i].ddrReg_)) |= (1 << RelayRegs[i].pin_);
    SetRelay(i, 0);
  }
}

void SetRelay(uint8_t RelayIndex, uint8_t IsOn)
{
  uint8_t ri = RelayIndex & 0x03;  // relay index is 0 to 3 for relays 1 to 4
  if(IsOn)
    *(RelayRegs[ri].portReg_) |= (1 << RelayRegs[ri].pin_);
  else
    *(RelayRegs[ri].portReg_) &= ~(1 << RelayRegs[ri].pin_);
}
