﻿Imports System.ComponentModel
Imports System.IO

Public Class frmMain

    Const IS_BETA = True

    Private bSetData As Boolean = False  'when true, data chnages are saved to Dada array
    Private bSettingsDirty As Boolean
    Private strFileNow As String = ""

    Private Const bit0 = 1
    Private Const bit1 = 2
    Private Const bit2 = 4
    Private Const bit3 = 8
    Private Const bit4 = 16
    Private Const bit5 = 32
    Private Const bit6 = 64
    Private Const bit7 = 128

    Private Data(396) As Byte
    Private Const dSetVersion = 0
    Private Const dMidiChan = 2
    Private Const dMidiMSB = 3
    Private Const dMidiLSB = 4
    Private Const dPatchNum0 = 5
    Private Const dPatchFx1 = 130       'F9 initial state is stored as bit 7 in patch number
    Private Const dBankRelay0 = 255
    Private Const dCcFx0 = 280
    Private Const dFxMomentary = 358    'F9 stored as flag
    Private Const dFxAfterPC = 359      'F9 stored as flag
    Private Const dFxPersist = 360      'F9 stored as flag
    Private Const dTapFswNum = 361
    Private Const dTapFxCount = 362
    Private Const dMeGroupFx12 = 363
    Private Const dPedalCcNum = 368
    Private Const dPedalAfterPC = 370
    Private Const dPedalToeDead = 372
    Private Const dPedalHeelDead = 374
    Private Const dPedalPanicVal = 376
    Private Const dCustomCcNum = 378
    Private Const dCustomCcVal0 = 380
    Private Const dFlags11 = 394
    Private Const dWaitAfterPC = 395
    Private Const dFlagsAxeFX = 396
    Private Const MaxData = 396

    Private PedalFullRange(1) As Boolean
    Private Const PedalAdcMin = 2044
    Private Const PedalAdcMax = 2046

#Region "Startup"

    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Me.Icon = System.Drawing.Icon.ExtractAssociatedIcon(Application.ExecutablePath)

        LoadLists()
        LoadDefaults()
        ShowSettings()

        bSettingsDirty = False
        bSetData = True

        If IS_BETA Then
            If My.Settings.ShowBeta <> Data(dSetVersion).ToString & Data(dSetVersion + 1).ToString Then
                My.Settings.ShowBeta = Data(dSetVersion).ToString & Data(dSetVersion + 1).ToString
                MessageBox.Show("This software is still in beta and has not been fully tested." & vbLf & vbLf & "Please report any problems to info@gmarts.org", "WARNING", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        End If

    End Sub

    Private Sub LoadLists()

        For i As Integer = 0 To 9
            If i < 5 Then
                lstTapFsw.Items.Add("Footswitch #" & (i + 1).ToString)
            Else
                lstTapFsw.Items.Add("Shifted Fsw #" & (i - 4).ToString)
            End If

            If i = 0 Then
                lstTapCount.Items.Add("(Off)")
            ElseIf i = 1 Then
                lstTapCount.Items.Add("1 press")
            Else
                lstTapCount.Items.Add(i.ToString & " presses")
            End If
        Next
        lstTapFsw.SelectedIndex = 4
        lstTapCount.SelectedIndex = 2

        lstAxeFxModel.Items.Add("Axe-FX II")
        lstAxeFxModel.Items.Add("Axe-FX II XL")
        lstAxeFxModel.Items.Add("Axe-FX II XL+")
        lstAxeFxModel.SelectedIndex = 0

    End Sub

    Private Sub LoadDefaults()

        'settings version 1.1
        Data(dSetVersion) = 1
        Data(dSetVersion + 1) = 1

        Data(dMidiChan) = 0 'saved as 0-based, displays 1-based
        Data(dMidiMSB) = 0
        Data(dMidiLSB) = 255

        For i As Integer = 0 To 124
            Data(dPatchNum0 + i) = i
            Data(dPatchFx1 + i) = 0
        Next

        Data(dBankRelay0) = Convert.ToByte("11110000", 2)
        Data(dBankRelay0 + 1) = Convert.ToByte("11110000", 2)
        Data(dBankRelay0 + 2) = Convert.ToByte("11110001", 2)
        Data(dBankRelay0 + 3) = Convert.ToByte("11110010", 2)
        Data(dBankRelay0 + 4) = Convert.ToByte("11110011", 2)
        For i As Integer = 5 To 25
            Data(dBankRelay0 + i) = 0
        Next

        Data(dCcFx0) = 25 : Data(dCcFx0 + 1) = 0 : Data(dCcFx0 + 2) = 127 : Data(dCcFx0 + 3) = 255 : Data(dCcFx0 + 4) = 0 : Data(dCcFx0 + 5) = 0                'F1
        Data(dCcFx0 + 6) = 26 : Data(dCcFx0 + 7) = 0 : Data(dCcFx0 + 8) = 127 : Data(dCcFx0 + 9) = 255 : Data(dCcFx0 + 10) = 0 : Data(dCcFx0 + 11) = 0
        Data(dCcFx0 + 12) = 36 : Data(dCcFx0 + 13) = 127 : Data(dCcFx0 + 14) = 0 : Data(dCcFx0 + 15) = 255 : Data(dCcFx0 + 16) = 0 : Data(dCcFx0 + 17) = 0
        Data(dCcFx0 + 18) = 29 : Data(dCcFx0 + 19) = 255 : Data(dCcFx0 + 20) = 0 : Data(dCcFx0 + 21) = 28 : Data(dCcFx0 + 22) = 0 : Data(dCcFx0 + 23) = 127
        Data(dCcFx0 + 24) = 18 : Data(dCcFx0 + 25) = 0 : Data(dCcFx0 + 26) = 127 : Data(dCcFx0 + 27) = 255 : Data(dCcFx0 + 28) = 0 : Data(dCcFx0 + 29) = 0      'F5
        Data(dCcFx0 + 30) = 113 : Data(dCcFx0 + 31) = 0 : Data(dCcFx0 + 32) = 127 : Data(dCcFx0 + 33) = 255 : Data(dCcFx0 + 34) = 0 : Data(dCcFx0 + 35) = 0
        Data(dCcFx0 + 36) = 27 : Data(dCcFx0 + 37) = 0 : Data(dCcFx0 + 38) = 127 : Data(dCcFx0 + 39) = 255 : Data(dCcFx0 + 40) = 0 : Data(dCcFx0 + 41) = 0
        Data(dCcFx0 + 42) = 50 : Data(dCcFx0 + 43) = 0 : Data(dCcFx0 + 44) = 127 : Data(dCcFx0 + 45) = 255 : Data(dCcFx0 + 46) = 0 : Data(dCcFx0 + 47) = 0
        Data(dCcFx0 + 48) = 17 : Data(dCcFx0 + 49) = 127 : Data(dCcFx0 + 50) = 0 : Data(dCcFx0 + 51) = 255 : Data(dCcFx0 + 52) = 0 : Data(dCcFx0 + 53) = 0      'F9
        Data(dCcFx0 + 54) = 64 : Data(dCcFx0 + 55) = 255 : Data(dCcFx0 + 56) = 127 : Data(dCcFx0 + 57) = 65 : Data(dCcFx0 + 58) = 0 : Data(dCcFx0 + 59) = 127   'Tap
        Data(dCcFx0 + 60) = 29 : Data(dCcFx0 + 61) = 255 : Data(dCcFx0 + 62) = 127 : Data(dCcFx0 + 63) = 28 : Data(dCcFx0 + 64) = 0 : Data(dCcFx0 + 65) = 127   'TapFX
        Data(dCcFx0 + 66) = 69 : Data(dCcFx0 + 67) = 127 : Data(dCcFx0 + 68) = 0 : Data(dCcFx0 + 69) = 255 : Data(dCcFx0 + 70) = 0 : Data(dCcFx0 + 71) = 0      'Pedal#1 Heel FX
        Data(dCcFx0 + 72) = 255 : Data(dCcFx0 + 73) = 0 : Data(dCcFx0 + 74) = 0 : Data(dCcFx0 + 75) = 255 : Data(dCcFx0 + 76) = 0 : Data(dCcFx0 + 77) = 0       'Pedal#2 Heel FX

        Data(dFxMomentary) = 0
        Data(dFxAfterPC) = Convert.ToByte("00001111", 2)
        Data(dFxPersist) = 0
        Data(dTapFswNum) = 5
        Data(dTapFxCount) = 2

        Data(dMeGroupFx12) = 0
        Data(dMeGroupFx12 + 1) = Convert.ToByte("00010000", 2)
        Data(dMeGroupFx12 + 2) = 0
        Data(dMeGroupFx12 + 3) = Convert.ToByte("00100010", 2)
        Data(dMeGroupFx12 + 4) = Convert.ToByte("00010000", 2)

        Data(dPedalCcNum) = 7 : Data(dPedalCcNum + 1) = 4
        Data(dPedalAfterPC) = 255 : Data(dPedalAfterPC + 1) = 0
        Data(dPedalToeDead) = 5 : Data(dPedalToeDead + 1) = 5
        Data(dPedalHeelDead) = 5 : Data(dPedalHeelDead + 1) = 5
        Data(dPedalPanicVal) = 127 + 128 : Data(dPedalPanicVal + 1) = 0

        Data(dCustomCcNum) = 16 : Data(dCustomCcNum + 1) = 16
        Data(dCustomCcVal0) = 56 : Data(dCustomCcVal0 + 1) = 64
        Data(dCustomCcVal0 + 2) = 8 : Data(dCustomCcVal0 + 3) = 0
        Data(dCustomCcVal0 + 4) = 30 : Data(dCustomCcVal0 + 5) = 38
        Data(dCustomCcVal0 + 6) = 43 : Data(dCustomCcVal0 + 7) = 51
        Data(dCustomCcVal0 + 8) = 68 : Data(dCustomCcVal0 + 9) = 76
        Data(dCustomCcVal0 + 10) = 81 : Data(dCustomCcVal0 + 11) = 89
        Data(dCustomCcVal0 + 12) = 94 : Data(dCustomCcVal0 + 13) = 102

        Data(dFlags11) = Convert.ToByte("10110011", 2)
        Data(dFlagsAxeFX) = Convert.ToByte("11000000", 2) + 3   '3 is model number for Axe-FX II
        Data(dWaitAfterPC) = 10

        PedalFullRange(0) = False
        PedalFullRange(1) = False

    End Sub

    Private Sub optVersion_CheckedChanged(sender As Object, e As EventArgs) Handles optV11.CheckedChanged, optV15.CheckedChanged, optV21.CheckedChanged
        'hide options not supported by selected version
        grpAxeFx.Visible = optV21.Checked
        grpBacktracking.Visible = Not optV15.Checked
        pnlBanks.Visible = Not optV15.Checked
        tabBanks.BackColor = IIf(optV15.Checked, SystemColors.Control, SystemColors.Window)
        pnlCustom.Visible = Not optV15.Checked
        tabCustom.BackColor = IIf(optV15.Checked, SystemColors.Control, SystemColors.Window)
        pnlPedalPanic.Visible = Not optV15.Checked
        grpMeGroups.Visible = (Not optV15.Checked) And (scrEffect.Value <= 8 Or scrEffect.Value = 10)
    End Sub

    Private Sub ShowSettings()

        bSetData = False

        'set all selectors to minimum
        scrPatch.Value = 0
        scrBank.Value = 0
        scrEffect.Value = 0
        chkEffectOffRelays.Checked = True : chkEffectOnRelays.Checked = False
        optPedal1.Checked = True : optPedal2.Checked = False
        optCustomMsgA.Checked = True : optCustomMsgB.Checked = False
        scrCustomRelay.Value = 0
        lstTapFsw.SelectedIndex = 0
        lstTapCount.SelectedIndex = 0
        lstAxeFxModel.SelectedIndex = 0

        'set values from Data()
        spnMidiChan.Value = Data(dMidiChan) + 1     'MIDI channel displays 1-based
        chkMidiMSB.Checked = (Data(dMidiMSB) < 128)
        If chkMidiMSB.Checked Then spnMidiMSB.Value = Data(dMidiMSB)
        chkMidiLSB.Checked = (Data(dMidiLSB) < 128)
        If chkMidiLSB.Checked Then spnMidiLSB.Value = Data(dMidiLSB)

        DisplayPatch()
        DisplayBank()
        DisplayEffect()
        DisplayPedals()
        DisplayCustom()
        DisplayOther()

    End Sub

    Private Sub DisplayPatch()

        Dim p As Integer = scrPatch.Value

        bSetData = False

        spnMidiPC.Value = (Data(dPatchNum0 + p) And &H7F)

        chkPatchF1.Checked = ((Data(dPatchFx1 + p) And bit0) <> 0)
        chkPatchF2.Checked = ((Data(dPatchFx1 + p) And bit1) <> 0)
        chkPatchF3.Checked = ((Data(dPatchFx1 + p) And bit2) <> 0)
        chkPatchF4.Checked = ((Data(dPatchFx1 + p) And bit3) <> 0)
        chkPatchF5.Checked = ((Data(dPatchFx1 + p) And bit4) <> 0)
        chkPatchF6.Checked = ((Data(dPatchFx1 + p) And bit5) <> 0)
        chkPatchF7.Checked = ((Data(dPatchFx1 + p) And bit6) <> 0)
        chkPatchF8.Checked = ((Data(dPatchFx1 + p) And bit7) <> 0)
        chkPatchF9.Checked = ((Data(dPatchNum0 + p) And bit7) <> 0)     'F9 state is stored as high bit of patch number

        bSetData = True

    End Sub

    Private Sub DisplayBank()

        Dim b As Byte = Data(dBankRelay0 + scrBank.Value)

        bSetData = False

        optBankRelay1NC.Checked = ((b And bit4) = 0)
        optBankRelay1Off.Checked = ((b And bit4) <> 0) And ((b And bit0) = 0)
        optBankRelay1On.Checked = ((b And bit4) <> 0) And ((b And bit0) <> 0)

        optBankRelay2NC.Checked = ((b And bit5) = 0)
        optBankRelay2Off.Checked = ((b And bit5) <> 0) And ((b And bit1) = 0)
        optBankRelay2On.Checked = ((b And bit5) <> 0) And ((b And bit1) <> 0)

        optBankRelay3NC.Checked = ((b And bit6) = 0)
        optBankRelay3Off.Checked = ((b And bit6) <> 0) And ((b And bit2) = 0)
        optBankRelay3On.Checked = ((b And bit6) <> 0) And ((b And bit2) <> 0)

        optBankRelay4NC.Checked = ((b And bit7) = 0)
        optBankRelay4Off.Checked = ((b And bit7) <> 0) And ((b And bit3) = 0)
        optBankRelay4On.Checked = ((b And bit7) <> 0) And ((b And bit3) <> 0)

        bSetData = True

    End Sub

    Private Sub DisplayEffect()

        Dim e As Byte = scrEffect.Value

        bSetData = False

        'show CC & relay data
        chkEffectCCaNum.Checked = (Data(dCcFx0 + (e * 6)) < 128)
        If chkEffectCCaNum.Checked Then spnEffectCCaNum.Value = Data(dCcFx0 + (e * 6))
        chkEffectCCaOff.Checked = (Data(dCcFx0 + (e * 6) + 1) < 128)
        If chkEffectCCaOff.Checked Then spnEffectCCaOff.Value = Data(dCcFx0 + (e * 6) + 1)
        chkEffectCCaOn.Checked = (Data(dCcFx0 + (e * 6) + 2) < 128)
        If chkEffectCCaOn.Checked Then spnEffectCCaOn.Value = Data(dCcFx0 + (e * 6) + 2)

        chkEffectCCbNum.Checked = (Data(dCcFx0 + (e * 6) + 3) < 128)
        If chkEffectCCbNum.Checked Then
            spnEffectCCbNum.Value = Data(dCcFx0 + (e * 6) + 3)
            chkEffectCCbOff.Checked = (Data(dCcFx0 + (e * 6) + 4) < 128)
            If chkEffectCCbOff.Checked Then spnEffectCCbOff.Value = Data(dCcFx0 + (e * 6) + 4)
            chkEffectCCbOn.Checked = (Data(dCcFx0 + (e * 6) + 5) < 128)
            If chkEffectCCbOn.Checked Then spnEffectCCbOn.Value = Data(dCcFx0 + (e * 6) + 5)
        End If

        'show relay settings
        chkEffectCCbRelays.Checked = (Data(dCcFx0 + (e * 6) + 3) = 128)
        If chkEffectCCbRelays.Checked Then
            ShowEffectRelays()
        End If

        'show specific effect settings
        Select Case e
            Case 0 To 7 'F1 to F8
                chkEffectMomentary.Checked = ((Data(dFxMomentary) And (2 ^ e)) <> 0)
                chkEffectSendAfterPC.Checked = ((Data(dFxAfterPC) And (2 ^ e)) <> 0)
                chkEffectPersistent.Checked = ((Data(dFxPersist) And (2 ^ e)) <> 0)
                ShowMeGroups(Data(dMeGroupFx12 + (e \ 2)), e Mod 2)
            Case 8  'F9
                chkEffectMomentary.Checked = ((Data(dFlags11) And bit2) <> 0)
                chkEffectSendAfterPC.Checked = ((Data(dFlags11) And bit1) <> 0)
                chkEffectPersistent.Checked = ((Data(dFlags11) And bit3) <> 0)
                ShowMeGroups(Data(dMeGroupFx12 + 4), 0)
            Case 9  'Tap fsw
                'do nothing
            Case 10 'Tap FX
                ShowMeGroups(Data(dMeGroupFx12 + 4), 1)
            Case 11 'Pedal #1 Heel FX
                'do nothing
            Case 12 'Pedal #2 Heel FX
                'do nothing
        End Select

        bSetData = True

    End Sub

    Private Sub ShowEffectRelays()

        Dim e As Byte = scrEffect.Value
        Dim r As Integer

        Dim bTemp = bSetData
        bSetData = False    'will restore state at end of this sub

        If chkEffectOffRelays.Checked Then
            r = Data(dCcFx0 + (e * 6) + 4)
        Else 'chkEffectOnRelays.Checked
            r = Data(dCcFx0 + (e * 6) + 5)
        End If

        optEffectRelay1NC.Checked = ((r And bit4) = 0)
        optEffectRelay1Off.Checked = ((r And bit4) <> 0) And ((r And bit0) = 0)
        optEffectRelay1On.Checked = ((r And bit4) <> 0) And ((r And bit0) <> 0)

        optEffectRelay2NC.Checked = ((r And bit5) = 0)
        optEffectRelay2Off.Checked = ((r And bit5) <> 0) And ((r And bit1) = 0)
        optEffectRelay2On.Checked = ((r And bit5) <> 0) And ((r And bit1) <> 0)

        optEffectRelay3NC.Checked = ((r And bit6) = 0)
        optEffectRelay3Off.Checked = ((r And bit6) <> 0) And ((r And bit2) = 0)
        optEffectRelay3On.Checked = ((r And bit6) <> 0) And ((r And bit2) <> 0)

        optEffectRelay4NC.Checked = ((r And bit7) = 0)
        optEffectRelay4Off.Checked = ((r And bit7) <> 0) And ((r And bit3) = 0)
        optEffectRelay4On.Checked = ((r And bit7) <> 0) And ((r And bit3) <> 0)

        bSetData = bTemp

    End Sub

    Private Sub ShowMeGroups(intData As Byte, Nib As Integer)

        Dim intBits As Byte

        Dim bTemp = bSetData
        bSetData = False    'will restore state at end of this sub

        If Nib = 0 Then
            intBits = intData And 255  'use low nibble
        Else
            intBits = intData >> 4     'use high nibble
        End If

        chkMeGroup1.Checked = ((intBits And bit0) <> 0)
        chkMeGroup2.Checked = ((intBits And bit1) <> 0)
        chkMeGroup3.Checked = ((intBits And bit2) <> 0)
        chkMeGroup4.Checked = ((intBits And bit3) <> 0)

        bSetData = bTemp

    End Sub

    Private Sub DisplayPedals()

        Dim p As Integer = IIf(optPedal1.Checked, 0, 1)

        bSetData = False

        chkPedalCcNum.Checked = (Data(dPedalCcNum + p) < 128)
        If chkPedalCcNum.Checked Then spnPedalCcNum.Value = Data(dPedalCcNum + p)

        chkPedalSendCcAfterPC.Checked = (Data(dPedalAfterPC + p) < 128) Or (Data(dPedalAfterPC + p) = 254)
        If (chkPedalSendCcAfterPC.Checked) And (Data(dPedalAfterPC + p) < 128) Then spnPedalSendCcAfterPC.Value = Data(dPedalAfterPC + p)
        optPedalSendCcAfterPC.Checked = (Data(dPedalAfterPC + p) = 254)     'send previous pedal value after patch change

        If Data(dPedalToeDead + p) <= 25 Then spnPedalDeadToe.Value = Data(dPedalToeDead + p)
        If Data(dPedalHeelDead + p) <= 25 Then spnPedalDeadHeel.Value = Data(dPedalHeelDead + p)

        chkPedalCcDisable.Checked = (Data(dPedalPanicVal + p) < 128)
        If chkPedalCcDisable.Checked Then spnPedalCcDisable.Value = Data(dPedalPanicVal + p)

        chkPedalFullRange.Checked = PedalFullRange(p)

        bSetData = True

    End Sub

    Private Sub DisplayCustom()

        Dim c As Integer = IIf(optCustomMsgA.Checked, 0, 1)

        bSetData = False

        chkCustomCcNum.Checked = (Data(dCustomCcNum + c) < 128)
        If chkCustomCcNum.Checked Then
            spnCustomCcNum.Value = Data(dCustomCcNum + c)
            chkCustomOff.Checked = (Data(dCustomCcVal0 + c) < 128)
            If chkCustomOff.Checked Then spnCustomOff.Value = Data(dCustomCcVal0 + c)
            chkCustom1.Checked = (Data(dCustomCcVal0 + 2 + c) < 128)
            If chkCustom1.Checked Then spnCustom1.Value = Data(dCustomCcVal0 + 2 + c)
            chkCustom2.Checked = (Data(dCustomCcVal0 + 4 + c) < 128)
            If chkCustom2.Checked Then spnCustom2.Value = Data(dCustomCcVal0 + 4 + c)
            chkCustom3.Checked = (Data(dCustomCcVal0 + 6 + c) < 128)
            If chkCustom3.Checked Then spnCustom3.Value = Data(dCustomCcVal0 + 6 + c)
            chkCustom4.Checked = (Data(dCustomCcVal0 + 8 + c) < 128)
            If chkCustom4.Checked Then spnCustom4.Value = Data(dCustomCcVal0 + 8 + c)
            chkCustom5.Checked = (Data(dCustomCcVal0 + 10 + c) < 128)
            If chkCustom5.Checked Then spnCustom5.Value = Data(dCustomCcVal0 + 10 + c)
            chkCustom6.Checked = (Data(dCustomCcVal0 + 12 + c) < 128)
            If chkCustom6.Checked Then spnCustom6.Value = Data(dCustomCcVal0 + 12 + c)
        End If

        chkCustomLast.Checked = ((Data(dFlags11) And bit7) <> 0)

        If c = 1 Then 'Message B
            chkCustomRelays.Checked = (Data(dCustomCcNum + c) = 128)
            If chkCustomRelays.Checked Then
                ShowCustomRelays()
            End If
        End If

        bSetData = True

    End Sub

    Private Sub ShowCustomRelays()

        Dim r As Integer = Data(dCustomCcVal0 + (scrCustomRelay.Value * 2) + 1)

        Dim bTemp = bSetData
        bSetData = False    'will restore state at end of this sub

        optCustomRelay1NC.Checked = ((r And bit4) = 0)
        optCustomRelay1Off.Checked = ((r And bit4) <> 0) And ((r And bit0) = 0)
        optCustomRelay1On.Checked = ((r And bit4) <> 0) And ((r And bit0) <> 0)

        optCustomRelay2NC.Checked = ((r And bit5) = 0)
        optCustomRelay2Off.Checked = ((r And bit5) <> 0) And ((r And bit1) = 0)
        optCustomRelay2On.Checked = ((r And bit5) <> 0) And ((r And bit1) <> 0)

        optCustomRelay3NC.Checked = ((r And bit6) = 0)
        optCustomRelay3Off.Checked = ((r And bit6) <> 0) And ((r And bit2) = 0)
        optCustomRelay3On.Checked = ((r And bit6) <> 0) And ((r And bit2) <> 0)

        optCustomRelay4NC.Checked = ((r And bit7) = 0)
        optCustomRelay4Off.Checked = ((r And bit7) <> 0) And ((r And bit3) = 0)
        optCustomRelay4On.Checked = ((r And bit7) <> 0) And ((r And bit3) <> 0)

        bSetData = bTemp

    End Sub

    Private Sub DisplayOther()

        bSetData = False

        If Data(dTapFswNum) > 0 And Data(dTapFswNum) <= 10 Then lstTapFsw.SelectedIndex = Data(dTapFswNum) - 1
        If Data(dTapFxCount) <= 9 Then lstTapCount.SelectedIndex = Data(dTapFxCount)
        chkFxShiftOffAfterPC.Checked = ((Data(dFlags11) And bit0) <> 0)
        spnWaitAfterPC.Value = Data(dWaitAfterPC)
        chkBacktrackOn.Checked = ((Data(dFlags11) And bit4) <> 0)
        chkBacktrackFx.Checked = ((Data(dFlags11) And bit5) <> 0)
        chkBacktrackBank.Checked = ((Data(dFlags11) And bit6) <> 0)

        Select Case Data(dFlagsAxeFX) And &H0F
            Case 3  'Axe-FX II
                lstAxeFxModel.SelectedIndex = 0
            Case 6  'Axe-FX II XL
                lstAxeFxModel.SelectedIndex = 1
            Case 7  'Axe-FX II XL+
                lstAxeFxModel.SelectedIndex = 2
        End Select

        chkAxeFxTuner.Checked = ((Data(dFlagsAxeFX) And bit7) <> 0)
        chkAxeFxTempo.Checked = ((Data(dFlagsAxeFX) And bit6) <> 0)

        bSetData = True

    End Sub

#End Region

#Region "Helper Functions"
    Private Function NoCC32(CheckVal As Integer, LastVal As Integer) As Integer
        If CheckVal = 32 Then
            If LastVal < 32 Then
                Return 33
            Else
                Return 31
            End If
        Else
            Return CheckVal
        End If
    End Function

    Private Sub SetData(intAddress As Integer, bytValue As Byte)
        If bSetData Then
            Data(intAddress) = bytValue
            bSettingsDirty = True
        End If
    End Sub

    Sub SetDataBit(bytBitVal As Byte, bValue As Boolean, intDataAddress As Integer)
        If bSetData Then
            If bValue Then  'set bit
                Data(intDataAddress) = Data(intDataAddress) Or bytBitVal
            Else    'clear bit
                Data(intDataAddress) = Data(intDataAddress) And (bytBitVal Xor 255)
            End If
            bSettingsDirty = True
        End If
    End Sub

#End Region

#Region "MIDI Tab"

    Private Sub chkMidiMSB_CheckedChanged(sender As Object, e As EventArgs) Handles chkMidiMSB.CheckedChanged
        spnMidiMSB.Enabled = sender.Checked
        SetData(dMidiMSB, IIf(sender.Checked, spnMidiMSB.Value, 255))
    End Sub

    Private Sub chkMidiLSB_CheckedChanged(sender As Object, e As EventArgs) Handles chkMidiLSB.CheckedChanged
        spnMidiLSB.Enabled = sender.Checked
        SetData(dMidiLSB, IIf(sender.Checked, spnMidiLSB.Value, 255))
    End Sub

    Private Sub spnMidiChan_ValueChanged(sender As Object, e As EventArgs) Handles spnMidiChan.ValueChanged
        SetData(dMidiChan, sender.Value - 1)
    End Sub

    Private Sub spnMidiMSB_ValueChanged(sender As Object, e As EventArgs) Handles spnMidiMSB.ValueChanged
        SetData(dMidiMSB, sender.Value)
    End Sub

    Private Sub spnMidiLSB_ValueChanged(sender As Object, e As EventArgs) Handles spnMidiLSB.ValueChanged
        SetData(dMidiLSB, sender.Value)
    End Sub

#End Region

#Region "Patch Tab"

    Private Sub scrPatch_ValueChanged(sender As Object, e As EventArgs) Handles scrPatch.ValueChanged
        Dim strBankGroup As String = Chr(65 + scrPatch.Value \ 25)
        Dim strBankNum As String = (1 + ((scrPatch.Value \ 5) Mod 5)).ToString
        labPatch.Text = "Patch " & strBankGroup & strBankNum & "-" & (1 + (scrPatch.Value Mod 5)).ToString
        labPatch.Refresh()
        DisplayPatch()
    End Sub

    Private Sub spnMidiPC_ValueChanged(sender As Object, e As EventArgs) Handles spnMidiPC.ValueChanged
        SetData(dPatchNum0 + scrPatch.Value, sender.Value Or (Data(dPatchNum0 + scrPatch.Value) And bit7))    ' retain F9 setting in bit7
    End Sub

    Private Sub chkPatchF1_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF1.CheckedChanged
        SetDataBit(bit0, sender.Checked, dPatchFx1 + scrPatch.Value)
    End Sub

    Private Sub chkPatchF2_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF2.CheckedChanged
        SetDataBit(bit1, sender.Checked, dPatchFx1 + scrPatch.Value)
    End Sub

    Private Sub chkPatchF3_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF3.CheckedChanged
        SetDataBit(bit2, sender.Checked, dPatchFx1 + scrPatch.Value)
    End Sub

    Private Sub chkPatchF4_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF4.CheckedChanged
        SetDataBit(bit3, sender.Checked, dPatchFx1 + scrPatch.Value)
    End Sub

    Private Sub chkPatchF5_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF5.CheckedChanged
        SetDataBit(bit4, sender.Checked, dPatchFx1 + scrPatch.Value)
    End Sub

    Private Sub chkPatchF6_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF6.CheckedChanged
        SetDataBit(bit5, sender.Checked, dPatchFx1 + scrPatch.Value)
    End Sub

    Private Sub chkPatchF7_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF7.CheckedChanged
        SetDataBit(bit6, sender.Checked, dPatchFx1 + scrPatch.Value)
    End Sub

    Private Sub chkPatchF8_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF8.CheckedChanged
        SetDataBit(bit7, sender.Checked, dPatchFx1 + scrPatch.Value)
    End Sub

    Private Sub chkPatchF9_CheckedChanged(sender As Object, e As EventArgs) Handles chkPatchF9.CheckedChanged
        SetDataBit(bit7, sender.Checked, dPatchNum0 + scrPatch.Value)    'F9 saved at bit 7 of patch number
    End Sub

#End Region

#Region "Banks Tab"

    Private Sub scrBank_ValueChanged(sender As Object, e As EventArgs) Handles scrBank.ValueChanged
        Dim strBankGroup As String = Chr(65 + sender.Value \ 5)
        labBank.Text = "Bank " & strBankGroup & (1 + (sender.Value Mod 5)).ToString
        labBank.Refresh()
        DisplayBank()
    End Sub

    Private Sub optBankRelay1NC_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay1NC.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit4, False, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay1Off_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay1Off.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit4, True, dBankRelay0 + scrBank.Value)
            SetDataBit(bit0, False, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay1On_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay1On.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit4, True, dBankRelay0 + scrBank.Value)
            SetDataBit(bit0, True, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay2NC_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay2NC.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit5, False, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay2Off_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay2Off.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit5, True, dBankRelay0 + scrBank.Value)
            SetDataBit(bit1, False, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay2On_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay2On.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit5, True, dBankRelay0 + scrBank.Value)
            SetDataBit(bit1, True, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay3NC_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay3NC.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit6, False, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay3Off_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay3Off.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit6, True, dBankRelay0 + scrBank.Value)
            SetDataBit(bit2, False, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay3On_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay3On.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit6, True, dBankRelay0 + scrBank.Value)
            SetDataBit(bit2, True, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay4NC_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay4NC.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit7, False, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay4Off_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay4Off.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit7, True, dBankRelay0 + scrBank.Value)
            SetDataBit(bit3, False, dBankRelay0 + scrBank.Value)
        End If
    End Sub

    Private Sub optBankRelay4On_CheckedChanged(sender As Object, e As EventArgs) Handles optBankRelay4On.CheckedChanged
        If sender.Checked Then
            SetDataBit(bit7, True, dBankRelay0 + scrBank.Value)
            SetDataBit(bit3, True, dBankRelay0 + scrBank.Value)
        End If
    End Sub

#End Region

#Region "Effects Tab"

    Private Sub scrEffect_ValueChanged(sender As Object, e As EventArgs) Handles scrEffect.ValueChanged
        Select Case scrEffect.Value
            Case 0 To 8
                labEffect.Text = "Effect F" & (1 + scrEffect.Value).ToString
                grpMeGroups.Visible = Not optV15.Checked
                chkEffectMomentary.Enabled = True
                chkEffectSendAfterPC.Enabled = True
                chkEffectPersistent.Enabled = True
            Case 9
                labEffect.Text = "Tap Press"
                grpMeGroups.Visible = False
                chkEffectMomentary.Enabled = False
                chkEffectMomentary.Checked = True
                chkEffectSendAfterPC.Enabled = False
                chkEffectSendAfterPC.Checked = False
                chkEffectPersistent.Enabled = False
                chkEffectPersistent.Checked = False
            Case 10
                labEffect.Text = "Tap Effects"
                grpMeGroups.Visible = Not optV15.Checked
                chkEffectMomentary.Enabled = False
                chkEffectMomentary.Checked = False
                chkEffectSendAfterPC.Enabled = False
                chkEffectSendAfterPC.Checked = False
                chkEffectPersistent.Enabled = False
                chkEffectPersistent.Checked = False
            Case 11
                labEffect.Text = "Pedal #1 Heel Effects"
                grpMeGroups.Visible = False
                chkEffectMomentary.Enabled = False
                chkEffectMomentary.Checked = False
                chkEffectSendAfterPC.Enabled = False
                chkEffectSendAfterPC.Checked = False
                chkEffectPersistent.Enabled = False
                chkEffectPersistent.Checked = False
            Case 12
                labEffect.Text = "Pedal #2 Heel Effects"
                grpMeGroups.Visible = False
                chkEffectMomentary.Enabled = False
                chkEffectMomentary.Checked = False
                chkEffectSendAfterPC.Enabled = False
                chkEffectSendAfterPC.Checked = False
                chkEffectPersistent.Enabled = False
                chkEffectPersistent.Checked = False
        End Select
        labEffect.Refresh()
        DisplayEffect()
    End Sub

    Private Sub chkEffectCCaNum_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectCCaNum.CheckedChanged
        spnEffectCCaNum.Enabled = sender.Checked
        chkEffectCCaOff.Enabled = sender.Checked
        spnEffectCCaOff.Enabled = (sender.Checked And chkEffectCCaOff.Checked)
        chkEffectCCaOn.Enabled = sender.Checked
        spnEffectCCaOn.Enabled = (sender.Checked And chkEffectCCaOn.Checked)
        SetData(dCcFx0 + (scrEffect.Value * 6), IIf(sender.Checked, spnEffectCCaNum.Value, 255))
    End Sub

    Private Sub chkEffectCCaOff_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectCCaOff.CheckedChanged
        spnEffectCCaOff.Enabled = (chkEffectCCaNum.Checked And sender.Checked)
        SetData(dCcFx0 + 1 + (scrEffect.Value * 6), IIf(sender.Checked, spnEffectCCaOff.Value, 255))
    End Sub

    Private Sub chkEffectCCaOn_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectCCaOn.CheckedChanged
        spnEffectCCaOn.Enabled = (chkEffectCCaNum.Checked And sender.Checked)
        SetData(dCcFx0 + 2 + (scrEffect.Value * 6), IIf(sender.Checked, spnEffectCCaOn.Value, 255))
    End Sub

    Private Sub chkEffectCCbNum_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectCCbNum.CheckedChanged
        If sender.Checked Then chkEffectCCbRelays.Checked = False
        spnEffectCCbNum.Enabled = sender.Checked
        chkEffectCCbOff.Enabled = sender.Checked
        spnEffectCCbOff.Enabled = (sender.Checked And chkEffectCCbOff.Checked)
        chkEffectCCbOn.Enabled = sender.Checked
        spnEffectCCbOn.Enabled = (sender.Checked And chkEffectCCbOn.Checked)
        SetData(dCcFx0 + 3 + (scrEffect.Value * 6), IIf(sender.Checked, spnEffectCCbNum.Value, IIf(chkEffectCCbRelays.Checked, 128, 255)))
        If sender.Checked Then
            'get data from spin controls to ensure data is not retained from relay settings (which use the entire range 0 to 255)
            SetData(dCcFx0 + 4 + (scrEffect.Value * 6), IIf(chkEffectCCbOff.Checked, spnEffectCCbOff.Value, 255))
            SetData(dCcFx0 + 5 + (scrEffect.Value * 6), IIf(chkEffectCCbOn.Checked, spnEffectCCbOn.Value, 255))
        End If
    End Sub

    Private Sub chkEffectCCbOff_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectCCbOff.CheckedChanged
        spnEffectCCbOff.Enabled = (sender.Checked And chkEffectCCbOff.Checked And (Not chkEffectCCbRelays.Checked))
        SetData(dCcFx0 + 4 + (scrEffect.Value * 6), IIf(chkEffectCCbOff.Checked, spnEffectCCbOff.Value, 255))
    End Sub

    Private Sub chkEffectCCbOn_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectCCbOn.CheckedChanged
        spnEffectCCbOn.Enabled = (chkEffectCCbNum.Checked And sender.Checked And (Not chkEffectCCbRelays.Checked))
        SetData(dCcFx0 + 5 + (scrEffect.Value * 6), IIf(sender.Checked, spnEffectCCbOn.Value, 255))
    End Sub

    Private Sub chkEffectCCbRelays_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectCCbRelays.CheckedChanged
        grpEffectRelays.Visible = sender.Checked
        If sender.Checked Then
            chkEffectCCbNum.Checked = False
            ShowEffectRelays()
        End If
        SetData(dCcFx0 + 3 + (scrEffect.Value * 6), IIf(chkEffectCCbNum.Checked, spnEffectCCbNum.Value, IIf(sender.Checked, 128, 255)))
    End Sub

    Private Sub chkEffectOffRelays_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectOffRelays.CheckedChanged
        ShowEffectRelays()
    End Sub

    Private Sub spnEffectCCaNum_ValueChanged(sender As Object, e As EventArgs) Handles spnEffectCCaNum.ValueChanged
        Static LastVal As Integer
        sender.Value = NoCC32(sender.Value, LastVal)
        LastVal = sender.Value
        SetData(dCcFx0 + (scrEffect.Value * 6), sender.Value)
    End Sub

    Private Sub spnEffectCCaOff_ValueChanged(sender As Object, e As EventArgs) Handles spnEffectCCaOff.ValueChanged
        SetData(dCcFx0 + 1 + (scrEffect.Value * 6), sender.Value)
    End Sub

    Private Sub spnEffectCCaOn_ValueChanged(sender As Object, e As EventArgs) Handles spnEffectCCaOn.ValueChanged
        SetData(dCcFx0 + 2 + (scrEffect.Value * 6), sender.Value)
    End Sub

    Private Sub spnEffectCCbNum_ValueChanged(sender As Object, e As EventArgs) Handles spnEffectCCbNum.ValueChanged
        Static LastVal As Integer
        sender.Value = NoCC32(sender.Value, LastVal)
        LastVal = sender.Value
        SetData(dCcFx0 + 3 + (scrEffect.Value * 6), sender.Value)
    End Sub

    Private Sub spnEffectCCbOff_ValueChanged(sender As Object, e As EventArgs) Handles spnEffectCCbOff.ValueChanged
        SetData(dCcFx0 + 4 + (scrEffect.Value * 6), sender.Value)
    End Sub

    Private Sub spnEffectCCbOn_ValueChanged(sender As Object, e As EventArgs) Handles spnEffectCCbOn.ValueChanged
        SetData(dCcFx0 + 5 + (scrEffect.Value * 6), sender.Value)
    End Sub

    Private Sub optEffectRelay1NC_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay1NC.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit4, False, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay1Off_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay1Off.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit4, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
            SetDataBit(bit0, False, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay1On_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay1On.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit4, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
            SetDataBit(bit0, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay2NC_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay2NC.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit5, False, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay2Off_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay2Off.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit5, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
            SetDataBit(bit1, False, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay2On_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay2On.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit5, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
            SetDataBit(bit1, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay3NC_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay3NC.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit6, False, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay3Off_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay3Off.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit6, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
            SetDataBit(bit2, False, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay3On_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay3On.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit6, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
            SetDataBit(bit2, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay4NC_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay4NC.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit7, False, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay4Off_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay4Off.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit7, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
            SetDataBit(bit3, False, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub optEffectRelay4On_CheckedChanged(sender As Object, e As EventArgs) Handles optEffectRelay4On.CheckedChanged
        If chkEffectCCbRelays.Checked And sender.Checked Then
            SetDataBit(bit7, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
            SetDataBit(bit3, True, dCcFx0 + IIf(chkEffectOffRelays.Checked, 4, 5) + (scrEffect.Value * 6))
        End If
    End Sub

    Private Sub chkEffectMomentary_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectMomentary.CheckedChanged
        If scrEffect.Value <= 7 Then    'F1 to F8
            SetDataBit(2 ^ scrEffect.Value, sender.Checked, dFxMomentary)
        ElseIf scrEffect.Value = 8 Then 'F9
            SetDataBit(bit2, sender.Checked, dFlags11)
        End If
        grpMeGroups.Enabled = Not sender.Checked
    End Sub

    Private Sub chkEffectSendAfterPC_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectSendAfterPC.CheckedChanged
        If scrEffect.Value <= 7 Then    'F1 to F8
            SetDataBit(2 ^ scrEffect.Value, sender.Checked, dFxAfterPC)
        ElseIf scrEffect.Value = 8 Then 'F9
            SetDataBit(bit1, sender.Checked, dFlags11)
        End If
    End Sub

    Private Sub chkEffectPersistent_CheckedChanged(sender As Object, e As EventArgs) Handles chkEffectPersistent.CheckedChanged
        If scrEffect.Value <= 7 Then    'F1 to F8
            SetDataBit(2 ^ scrEffect.Value, sender.Checked, dFxPersist)
        ElseIf scrEffect.Value = 8 Then 'F9
            SetDataBit(bit3, sender.Checked, dFlags11)
        End If
    End Sub

    Private Sub chkMeGroup1_CheckedChanged(sender As Object, e As EventArgs) Handles chkMeGroup1.CheckedChanged
        If scrEffect.Value <= 8 Then    'F1 to F9
            SetDataBit(IIf(scrEffect.Value Mod 2 = 0, bit0, bit4), sender.Checked, dMeGroupFx12 + scrEffect.Value \ 2)
        ElseIf scrEffect.Value = 10 Then    'TapFX
            SetDataBit(bit4, sender.Checked, dMeGroupFx12 + 4)
        End If
    End Sub

    Private Sub chkMeGroup2_CheckedChanged(sender As Object, e As EventArgs) Handles chkMeGroup2.CheckedChanged
        If scrEffect.Value <= 8 Then    'F1 to F9
            SetDataBit(IIf(scrEffect.Value Mod 2 = 0, bit1, bit5), sender.Checked, dMeGroupFx12 + scrEffect.Value \ 2)
        ElseIf scrEffect.Value = 10 Then    'TapFX
            SetDataBit(bit5, sender.Checked, dMeGroupFx12 + 4)
        End If
    End Sub

    Private Sub chkMeGroup3_CheckedChanged(sender As Object, e As EventArgs) Handles chkMeGroup3.CheckedChanged
        If scrEffect.Value <= 8 Then    'F1 to F9
            SetDataBit(IIf(scrEffect.Value Mod 2 = 0, bit2, bit6), sender.Checked, dMeGroupFx12 + scrEffect.Value \ 2)
        ElseIf scrEffect.Value = 10 Then    'TapFX
            SetDataBit(bit6, sender.Checked, dMeGroupFx12 + 4)
        End If
    End Sub

    Private Sub chkMeGroup4_CheckedChanged(sender As Object, e As EventArgs) Handles chkMeGroup4.CheckedChanged
        If scrEffect.Value <= 8 Then    'F1 to F9
            SetDataBit(IIf(scrEffect.Value Mod 2 = 0, bit3, bit7), sender.Checked, dMeGroupFx12 + scrEffect.Value \ 2)
        ElseIf scrEffect.Value = 10 Then    'TapFX
            SetDataBit(bit7, sender.Checked, dMeGroupFx12 + 4)
        End If
    End Sub

#End Region

#Region "Pedals Tab"

    Private Sub optPedal1_CheckedChanged(sender As Object, e As EventArgs) Handles optPedal1.CheckedChanged
        DisplayPedals()
    End Sub

    Private Sub chkPedalCcNum_CheckedChanged(sender As Object, e As EventArgs) Handles chkPedalCcNum.CheckedChanged
        spnPedalCcNum.Enabled = sender.Checked
        chkPedalSendCcAfterPC.Enabled = sender.Checked
        spnPedalSendCcAfterPC.Enabled = (sender.Checked And chkPedalSendCcAfterPC.Checked)
        optPedalSendCcAfterPC.Enabled = (sender.Checked And chkPedalSendCcAfterPC.Checked)
        spnPedalDeadToe.Enabled = sender.Checked
        spnPedalDeadHeel.Enabled = sender.Checked
        chkPedalCcDisable.Enabled = sender.Checked
        spnPedalCcDisable.Enabled = (sender.Checked And chkPedalCcDisable.Checked)
        SetData(dPedalCcNum + IIf(optPedal1.Checked, 0, 1), IIf(sender.Checked, spnPedalCcNum.Value, 255))
    End Sub

    Private Sub spnPedalCcNum_ValueChanged(sender As Object, e As EventArgs) Handles spnPedalCcNum.ValueChanged
        Static LastVal As Integer
        sender.Value = NoCC32(sender.Value, LastVal)
        LastVal = sender.Value
        SetData(dPedalCcNum + IIf(optPedal1.Checked, 0, 1), sender.Value)
    End Sub

    Private Sub chkPedalSendCcAfterPC_CheckedChanged(sender As Object, e As EventArgs) _
        Handles chkPedalSendCcAfterPC.CheckedChanged, optPedalSendCcAfterPC.CheckedChanged
        spnPedalSendCcAfterPC.Enabled = chkPedalSendCcAfterPC.Checked And (Not optPedalSendCcAfterPC.Checked)
        optPedalSendCcAfterPC.Enabled = chkPedalSendCcAfterPC.Checked
        If chkPedalSendCcAfterPC.Checked Then
            SetData(dPedalAfterPC + IIf(optPedal1.Checked, 0, 1), IIf(optPedalSendCcAfterPC.Checked, 254, spnPedalSendCcAfterPC.Value))
        Else
            SetData(dPedalAfterPC + IIf(optPedal1.Checked, 0, 1), 255)
        End If
    End Sub

    Private Sub spnPedalSendCcAfterPC_ValueChanged(sender As Object, e As EventArgs) Handles spnPedalSendCcAfterPC.ValueChanged
        SetData(dPedalAfterPC + IIf(optPedal1.Checked, 0, 1), sender.Value)
    End Sub

    Private Sub spnPedalDeadToe_ValueChanged(sender As Object, e As EventArgs) Handles spnPedalDeadToe.ValueChanged
        SetData(dPedalToeDead + IIf(optPedal1.Checked, 0, 1), sender.Value)
    End Sub

    Private Sub spnPedalDeadHeel_ValueChanged(sender As Object, e As EventArgs) Handles spnPedalDeadHeel.ValueChanged
        SetData(dPedalHeelDead + IIf(optPedal1.Checked, 0, 1), sender.Value)
    End Sub

    Private Sub chkPedalCcDisable_CheckedChanged(sender As Object, e As EventArgs) Handles chkPedalCcDisable.CheckedChanged
        spnPedalCcDisable.Enabled = sender.Checked
        SetData(dPedalPanicVal + IIf(optPedal1.Checked, 0, 1), IIf(sender.Checked, spnPedalCcDisable.Value, 255))
    End Sub

    Private Sub spnPedalCcDisable_ValueChanged(sender As Object, e As EventArgs) Handles spnPedalCcDisable.ValueChanged
        SetData(dPedalPanicVal + IIf(optPedal1.Checked, 0, 1), sender.Value)
    End Sub

    Private Sub chkPedalFullRange_CheckedChanged(sender As Object, e As EventArgs) Handles chkPedalFullRange.CheckedChanged
        PedalFullRange(IIf(optPedal1.Checked, 0, 1)) = sender.Checked
        bSettingsDirty = True
    End Sub

#End Region

#Region "Custom Tab"

    Private Sub optCustomMsgB_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomMsgB.CheckedChanged
        bSetData = False
        chkCustomRelays.Visible = sender.Checked
        If chkCustomRelays.Checked And sender.Checked Then chkCustomCcNum.Checked = False
        spnCustomCcNum.Enabled = chkCustomCcNum.Checked And (Not (chkCustomRelays.Checked And sender.Checked))
        grpCustomRelays.Visible = chkCustomRelays.Checked And sender.Checked
        DisplayCustom()
        bSetData = True
    End Sub

    Private Sub chkCustomCcNum_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustomCcNum.CheckedChanged
        If sender.Checked And chkCustomRelays.Visible Then chkCustomRelays.Checked = False
        spnCustomCcNum.Enabled = sender.Checked And (Not (chkCustomRelays.Checked And chkCustomRelays.Visible))
        chkCustomOff.Enabled = sender.Checked
        chkCustom1.Enabled = sender.Checked
        chkCustom2.Enabled = sender.Checked
        chkCustom3.Enabled = sender.Checked
        chkCustom4.Enabled = sender.Checked
        chkCustom5.Enabled = sender.Checked
        chkCustom6.Enabled = sender.Checked
        spnCustomOff.Enabled = chkCustomOff.Checked And sender.Checked
        spnCustom1.Enabled = chkCustom1.Checked And sender.Checked
        spnCustom2.Enabled = chkCustom2.Checked And sender.Checked
        spnCustom3.Enabled = chkCustom3.Checked And sender.Checked
        spnCustom4.Enabled = chkCustom4.Checked And sender.Checked
        spnCustom5.Enabled = chkCustom5.Checked And sender.Checked
        spnCustom6.Enabled = chkCustom6.Checked And sender.Checked
        SetData(dCustomCcNum + IIf(optCustomMsgA.Checked, 0, 1), IIf(sender.Checked, spnCustomCcNum.Value, IIf(optCustomMsgB.Checked And chkCustomRelays.Checked, 128, 255)))
        If sender.Checked Then
            'get data from spin controls to ensure data is not retained from relay settings (which use the entire range 0 to 255)
            SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 0, 1), IIf(chkCustomOff.Checked, spnCustomOff.Value, 255))
            SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 2, 3), IIf(chkCustom1.Checked, spnCustom1.Value, 255))
            SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 4, 5), IIf(chkCustom2.Checked, spnCustom2.Value, 255))
            SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 6, 7), IIf(chkCustom3.Checked, spnCustom3.Value, 255))
            SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 8, 9), IIf(chkCustom4.Checked, spnCustom4.Value, 255))
            SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 10, 11), IIf(chkCustom5.Checked, spnCustom5.Value, 255))
            SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 12, 13), IIf(chkCustom6.Checked, spnCustom6.Value, 255))
        End If
    End Sub

    Private Sub spnCustomCcNum_ValueChanged(sender As Object, e As EventArgs) Handles spnCustomCcNum.ValueChanged
        Static LastVal As Integer
        sender.Value = NoCC32(sender.Value, LastVal)
        LastVal = sender.Value
        SetData(dCustomCcNum + IIf(optCustomMsgA.Checked, 0, 1), sender.Value)
    End Sub

    Private Sub chkCustomRelays_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustomRelays.CheckedChanged
        grpCustomRelays.Visible = sender.Checked And sender.Visible
        If sender.Checked Then
            chkCustomCcNum.Checked = False
            ShowCustomRelays()
        End If
        SetData(dCustomCcNum + IIf(optCustomMsgA.Checked, 0, 1), IIf(chkCustomCcNum.Checked, spnCustomCcNum.Value, IIf(optCustomMsgB.Checked And chkCustomRelays.Checked, 128, 255)))
    End Sub

    Private Sub chkCustomOff_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustomOff.CheckedChanged
        spnCustomOff.Enabled = sender.Checked And chkCustomCcNum.Checked
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 0, 1), IIf(sender.Checked, spnCustomOff.Value, 255))
    End Sub

    Private Sub chkCustom1_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustom1.CheckedChanged
        spnCustom1.Enabled = sender.Checked And chkCustomCcNum.Checked
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 2, 3), IIf(sender.Checked, spnCustom1.Value, 255))
    End Sub

    Private Sub chkCustom2_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustom2.CheckedChanged
        spnCustom2.Enabled = sender.Checked And chkCustomCcNum.Checked
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 4, 5), IIf(sender.Checked, spnCustom2.Value, 255))
    End Sub

    Private Sub chkCustom3_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustom3.CheckedChanged
        spnCustom3.Enabled = sender.Checked And chkCustomCcNum.Checked
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 6, 7), IIf(sender.Checked, spnCustom3.Value, 255))
    End Sub

    Private Sub chkCustom4_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustom4.CheckedChanged
        spnCustom4.Enabled = sender.Checked And chkCustomCcNum.Checked
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 8, 9), IIf(sender.Checked, spnCustom4.Value, 255))
    End Sub

    Private Sub chkCustom5_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustom5.CheckedChanged
        spnCustom5.Enabled = sender.Checked And chkCustomCcNum.Checked
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 10, 11), IIf(sender.Checked, spnCustom5.Value, 255))
    End Sub

    Private Sub chkCustom6_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustom6.CheckedChanged
        spnCustom6.Enabled = sender.Checked And chkCustomCcNum.Checked
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 12, 13), IIf(sender.Checked, spnCustom6.Value, 255))
    End Sub

    Private Sub spnCustomOff_ValueChanged(sender As Object, e As EventArgs) Handles spnCustomOff.ValueChanged
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 0, 1), sender.Value)
    End Sub

    Private Sub spnCustom1_ValueChanged(sender As Object, e As EventArgs) Handles spnCustom1.ValueChanged
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 2, 3), sender.Value)
    End Sub

    Private Sub spnCustom2_ValueChanged(sender As Object, e As EventArgs) Handles spnCustom2.ValueChanged
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 4, 5), sender.Value)
    End Sub

    Private Sub spnCustom3_ValueChanged(sender As Object, e As EventArgs) Handles spnCustom3.ValueChanged
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 6, 7), sender.Value)
    End Sub

    Private Sub spnCustom4_ValueChanged(sender As Object, e As EventArgs) Handles spnCustom4.ValueChanged
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 8, 9), sender.Value)
    End Sub

    Private Sub spnCustom5_ValueChanged(sender As Object, e As EventArgs) Handles spnCustom5.ValueChanged
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 10, 11), sender.Value)
    End Sub

    Private Sub spnCustom6_ValueChanged(sender As Object, e As EventArgs) Handles spnCustom6.ValueChanged
        SetData(dCustomCcVal0 + IIf(optCustomMsgA.Checked, 12, 13), sender.Value)
    End Sub

    Private Sub chkCustomLast_CheckedChanged(sender As Object, e As EventArgs) Handles chkCustomLast.CheckedChanged
        SetDataBit(bit7, sender.Checked, dFlags11)
    End Sub

    Private Sub scrCustomRelay_ValueChanged(sender As Object, e As EventArgs) Handles scrCustomRelay.ValueChanged
        If sender.Value = 0 Then
            labCustomRelay.Text = "Custom Off"
        Else
            labCustomRelay.Text = "Custom #" & sender.Value.ToString
        End If
        labCustomRelay.Refresh()
        ShowCustomRelays()
    End Sub

    Private Sub optCustomRelay1NC_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay1NC.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit4, False, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay1Off_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay1Off.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit4, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
            SetDataBit(bit0, False, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay1On_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay1On.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit4, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
            SetDataBit(bit0, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay2NC_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay2NC.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit5, False, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay2Off_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay2Off.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit5, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
            SetDataBit(bit1, False, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay2On_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay2On.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit5, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
            SetDataBit(bit1, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay3NC_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay3NC.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit6, False, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay3Off_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay3Off.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit6, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
            SetDataBit(bit2, False, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay3On_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay3On.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit6, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
            SetDataBit(bit2, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay4NC_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay4NC.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit7, False, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay4Off_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay4Off.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit7, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
            SetDataBit(bit3, False, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

    Private Sub optCustomRelay4On_CheckedChanged(sender As Object, e As EventArgs) Handles optCustomRelay4On.CheckedChanged
        If chkCustomRelays.Checked And optCustomMsgB.Checked And sender.Checked Then
            SetDataBit(bit7, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
            SetDataBit(bit3, True, dCustomCcVal0 + 1 + (scrCustomRelay.Value * 2))
        End If
    End Sub

#End Region

#Region "Other Tab"

    Private Sub lstTapFsw_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lstTapFsw.SelectedIndexChanged
        SetData(dTapFswNum, sender.SelectedIndex + 1)
    End Sub

    Private Sub lstTapCount_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lstTapCount.SelectedIndexChanged
        SetData(dTapFxCount, sender.SelectedIndex)
    End Sub

    Private Sub chkFxShiftOffAfterPC_CheckedChanged(sender As Object, e As EventArgs) Handles chkFxShiftOffAfterPC.CheckedChanged
        SetDataBit(bit0, sender.Checked, dFlags11)
    End Sub

    Private Sub spnWaitAfterPC_ValueChanged(sender As Object, e As EventArgs) Handles spnWaitAfterPC.ValueChanged
        SetData(dWaitAfterPC, sender.Value)
    End Sub

    Private Sub chkBacktrackOn_CheckedChanged(sender As Object, e As EventArgs) Handles chkBacktrackOn.CheckedChanged
        chkBacktrackFx.Enabled = sender.Checked
        chkBacktrackBank.Enabled = sender.Checked
        chkAxeFxTempo.Enabled = sender.Checked
        SetDataBit(bit4, sender.Checked, dFlags11)
    End Sub

    Private Sub chkBacktrackFx_CheckedChanged(sender As Object, e As EventArgs) Handles chkBacktrackFx.CheckedChanged
        SetDataBit(bit5, sender.Checked, dFlags11)
    End Sub

    Private Sub chkBacktrackBank_CheckedChanged(sender As Object, e As EventArgs) Handles chkBacktrackBank.CheckedChanged
        SetDataBit(bit6, sender.Checked, dFlags11)
    End Sub

    Private Sub lstAxeFxModel_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lstAxeFxModel.SelectedIndexChanged
        Select Case sender.SelectedIndex 'store model ID in low nibble
            Case 0 : SetData(dFlagsAxeFX, (Data(dFlagsAxeFX) And &HF0) + 3)   'Axe-FX
            Case 1 : SetData(dFlagsAxeFX, (Data(dFlagsAxeFX) And &HF0) + 6)   'Axe-FX XL
            Case 2 : SetData(dFlagsAxeFX, (Data(dFlagsAxeFX) And &HF0) + 7)   'Axe-FX XL+
        End Select
    End Sub

    Private Sub chkAxeFxTuner_CheckedChanged(sender As Object, e As EventArgs) Handles chkAxeFxTuner.CheckedChanged
        SetDataBit(bit7, sender.Checked, dFlagsAxeFX)
    End Sub

    Private Sub chkAxeFxTempo_CheckedChanged(sender As Object, e As EventArgs) Handles chkAxeFxTempo.CheckedChanged
        SetDataBit(bit6, sender.Checked, dFlagsAxeFX)
    End Sub

#End Region

#Region "Menus"

    Private Sub frmMain_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown

        'menu shortcut keys
        If e.KeyCode = Keys.F1 Then
            MenuHelpGuide()

        ElseIf My.Computer.Keyboard.CtrlKeyDown Then
            Select Case e.KeyCode
                Case Keys.N
                    MenuFileNew()
                Case Keys.O
                    MenuFileOpen()
                Case Keys.S
                    MenuFileSave()
                Case Keys.A
                    MenuFileSaveAs()
            End Select
        End If

    End Sub

    Private Sub File_New_Click(sender As Object, e As EventArgs) Handles NewToolStripMenuItem.Click
        MenuFileNew()
    End Sub

    Private Sub File_Open_Click(sender As Object, e As EventArgs) Handles OpenToolStripMenuItem.Click
        MenuFileOpen()
    End Sub

    Private Sub File_Save_Click(sender As Object, e As EventArgs) Handles SaveToolStripMenuItem.Click
        MenuFileSave()
    End Sub

    Private Sub File_SaveAs_Click(sender As Object, e As EventArgs) Handles SaveAsToolStripMenuItem.Click
        MenuFileSaveAs()
    End Sub

    Private Sub MenuFileNew()

        If SaveIfDirty() Then
            LoadDefaults()
            ShowSettings()
            strFileNow = ""
            Me.Text = My.Application.Info.ProductName
            bSetData = True
            bSettingsDirty = False
            MessageBox.Show("Defaults loded for new file", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

    End Sub

    Private Sub MenuFileOpen()
        Dim strTextLine As String
        Dim bErrorChecking As Boolean = True
        Dim bAbortLoad As Boolean = False
        Dim intStartAddress As Integer
        Dim intEndAddress As Integer
        Dim d As Integer

        If SaveIfDirty() Then
            OpenFileDialog1.Filter = "EEP Files (*.eep)|*.eep"
            If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                If File.Exists(OpenFileDialog1.FileName) Then
                    strFileNow = OpenFileDialog1.FileName
                    Me.Text = My.Application.Info.ProductName & ":  " & FilenameOnly(OpenFileDialog1.FileName)
                    LoadDefaults()  'any missing data will use defaults
                    Dim objReader As New System.IO.StreamReader(OpenFileDialog1.FileName)
                    Do While objReader.Peek() <> -1
                        strTextLine = Trim(objReader.ReadLine())
                        If strTextLine.ToUpper = ":00000001FF" Then
                            Exit Do 'end of settings data
                        ElseIf Len(strTextLine) <> 0 Then  'not a blank line
                            If strTextLine.Substring(0, 1) = ":" Then  'settings data 
                                If Len(strTextLine) < 13 Then
                                    If bErrorChecking Then
                                        Select Case MessageBox.Show("Data line too short:" & vbLf & strTextLine & vbLf & vbLf & "Continue, ignoring lines with errors?",
                                                    My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                                            Case DialogResult.OK
                                                bErrorChecking = False
                                            Case Else   'cancel
                                                bAbortLoad = True
                                                Exit Do
                                        End Select
                                        'Else ignore this line if no longer error checking
                                    End If
                                ElseIf strTextLine.Substring(7, 2) <> "00" Then
                                    If bErrorChecking Then
                                        Select Case MessageBox.Show("Not a data line:" & vbLf & strTextLine & vbLf & vbLf & "Continue, ignoring lines with errors?",
                                                    My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                                            Case DialogResult.OK
                                                bErrorChecking = False
                                            Case Else   'cancel
                                                bAbortLoad = True
                                                Exit Do
                                        End Select
                                        'Else ignore this line if no longer error checking
                                    End If
                                ElseIf CheckSum(strTextLine.Substring(1, Len(strTextLine) - 3)).ToUpper <> Strings.Right(strTextLine, 2).ToUpper Then
                                    If bErrorChecking Then
                                        Select Case MessageBox.Show("Not a data line:" & vbLf & strTextLine & vbLf & vbLf & "Continue, ignoring lines with errors?",
                                                    My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                                            Case DialogResult.OK
                                                bErrorChecking = False
                                            Case Else   'cancel
                                                bAbortLoad = True
                                                Exit Do
                                        End Select
                                        'Else ignore this line if no longer error checking
                                    End If
                                ElseIf (Convert.ToByte(strTextLine.Substring(1, 2), 16) * 2) + 11 <> Len(strTextLine) Then
                                    If bErrorChecking Then
                                        Select Case MessageBox.Show("Incorrect line length:" & vbLf & strTextLine & vbLf & vbLf & "Continue, ignoring lines with errors?",
                                                    My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                                            Case DialogResult.OK
                                                bErrorChecking = False
                                            Case Else   'cancel
                                                bAbortLoad = True
                                                Exit Do
                                        End Select
                                        'Else ignore this line if no longer error checking
                                    End If

                                Else
                                    intStartAddress = Convert.ToByte(strTextLine.Substring(3, 2), 16) * 256 'MSB
                                    intStartAddress += Convert.ToByte(strTextLine.Substring(5, 2), 16)      'LSB
                                    intEndAddress = intStartAddress + Convert.ToByte(strTextLine.Substring(1, 2), 16) - 1
                                    If (intStartAddress = intEndAddress) And intStartAddress >= 2044 And intStartAddress <= 2047 Then
                                        'ok - these lines save a single byte of pedal calibration data
                                        Select Case intStartAddress
                                            Case 2044, 2046
                                                PedalFullRange(0) = True    'we just note the fact that these settings are being saved (not the save values)
                                            Case 2045, 2047
                                                PedalFullRange(1) = True
                                        End Select
                                    ElseIf intEndAddress > MaxData Then
                                        If bErrorChecking Then
                                            Select Case MessageBox.Show("Data address past end of this version of settings:" & vbLf & strTextLine & vbLf & vbLf & "Continue, ignoring lines with errors?",
                                                    My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                                                Case DialogResult.OK
                                                    bErrorChecking = False
                                                Case Else   'cancel
                                                    bAbortLoad = True
                                                    Exit Do
                                            End Select
                                            'Else ignore this line if no longer error checking
                                        End If
                                    Else
                                        'load the data
                                        d = 9   'pointer to start of hex pair data in strTextLine
                                        For a As Integer = intStartAddress To intEndAddress
                                            Data(a) = Convert.ToByte(strTextLine.Substring(d, 2), 16)
                                            d += 2
                                        Next
                                    End If
                                End If
                            End If
                        End If
                    Loop
                    objReader.Close()

                    If bAbortLoad Then
                        LoadDefaults()
                    End If
                    ShowSettings()
                    bSetData = True
                    bSettingsDirty = False
                Else
                    MessageBox.Show("Cannot find file:" & vbLf & OpenFileDialog1.FileName, My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            End If
        End If
    End Sub

    Private Sub MenuFileSave()
        If strFileNow = "" Then
            MenuFileSaveAs()
        Else
            SaveFile(strFileNow)
            MessageBox.Show("EEP file saved", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub File_Exit_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        If SaveIfDirty() Then
            Me.Close()
        End If
    End Sub

    Private Sub MenuFileSaveAs()

        SaveFileDialog1.Filter = "EEP Files (*.eep)|*.eep"
        SaveFileDialog1.FileName = strFileNow
        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            strFileNow = SaveFileDialog1.FileName
            SaveFile(strFileNow)
        End If

    End Sub

    Private Sub SaveFile(strFileName As String)

        Dim objWriter As New System.IO.StreamWriter(strFileName)
        Dim strOutput As String
        Dim i As Integer
        Dim LastIndex As Integer

        '.eep files
        'text files with byte pairs in this line format:
        ':ccaaaattdd...ddss<cr><lf>
        'cc = data byte count, typically 10 for 16 bytes
        'aaaa is address for first byte (1st pair is MSB)
        'tt is record type = 00 for data
        'dd is data byte hex pairs
        'ss is checksum: add all byte pairs, & 255 for LSB, then get two's complement:  Checksum = CByte((LSB_Total) Xor 255) + 1)
        'last line is:
        ':00000001FF

        'for all versions
        LastIndex = dBankRelay0 - 1
        For i = dSetVersion To LastIndex Step 16
            If SaveEep(i, LastIndex, objWriter) Then Exit For
        Next

        'for non v1.5
        If Not optV15.Checked Then
            LastIndex = dCcFx0 - 1
            For i = dBankRelay0 To LastIndex Step 16
                If SaveEep(i, LastIndex, objWriter) Then Exit For
            Next
        End If

        'for all versions
        LastIndex = dMeGroupFx12 - 1
        For i = dCcFx0 To LastIndex Step 16
            If SaveEep(i, LastIndex, objWriter) Then Exit For
        Next

        'for non v1.5
        If Not optV15.Checked Then
            LastIndex = dPedalCcNum - 1
            For i = dMeGroupFx12 To LastIndex Step 16
                If SaveEep(i, LastIndex, objWriter) Then Exit For
            Next
        End If

        'for all versions
        LastIndex = dPedalPanicVal - 1
        For i = dPedalCcNum To LastIndex Step 16
            If SaveEep(i, LastIndex, objWriter) Then Exit For
        Next

        'for non v1.5
        If Not optV15.Checked Then
            LastIndex = dFlags11 - 1
            For i = dPedalPanicVal To LastIndex Step 16
                If SaveEep(i, LastIndex, objWriter) Then Exit For
            Next
        End If

        'for all versions, but last byte for v2.1 only
        LastIndex = dFlagsAxeFX - IIf(optV21.Checked, 0, 1)
        For i = dFlags11 To LastIndex Step 16
            If SaveEep(i, LastIndex, objWriter) Then Exit For
        Next

        'optional pedal range data
        For i = 0 To 1
            If PedalFullRange(i) Then
                strOutput = "01" & Val2HexPair((PedalAdcMin + i) \ 256) & Val2HexPair((PedalAdcMin + i) And 255) & "0000"
                strOutput &= CheckSum(strOutput)
                objWriter.WriteLine(":" & strOutput)
                strOutput = "01" & Val2HexPair((PedalAdcMax + i) \ 256) & Val2HexPair((PedalAdcMax + i) And 255) & "00FF"
                strOutput &= CheckSum(strOutput)
                objWriter.WriteLine(":" & strOutput)
            End If
        Next

        objWriter.WriteLine(":00000001FF")  'last line
        objWriter.Close()

        strFileNow = strFileName
        Me.Text = My.Application.Info.ProductName & ":  " & FilenameOnly(OpenFileDialog1.FileName)
        bSettingsDirty = False

    End Sub

    Private Function SaveEep(i As Integer, LastInd As Integer, objFileOut As StreamWriter) As Boolean

        Dim strOutput As String
        Dim intByteCount As Integer
        Dim j As Integer

        strOutput = ""
        intByteCount = 0

        For j = 0 To 15
            If i + j > LastInd Then Exit For
            'assemble & count data bytes first
            strOutput &= Val2HexPair(Data(i + j))
            intByteCount += 1
        Next

        If intByteCount > 0 Then
            strOutput = "00" & strOutput                        'pre-pend data type
            strOutput = Val2HexPair(i And 255) & strOutput      'pre-pend LSB of address
            strOutput = Val2HexPair(i \ 256) & strOutput        'pre-pend MSB of address
            strOutput = Val2HexPair(intByteCount) & strOutput   'pre-pend data byte count
            strOutput &= CheckSum(strOutput)                    'append checksum
            objFileOut.WriteLine(":" & strOutput)               'write to file
        End If

        Return (i + j > LastInd)

    End Function

    Private Function CheckSum(strHex As String) As String

        Dim c As Integer = Len(strHex)
        Dim strHexPair As String
        Dim intLsbSum As Integer

        If ((c Mod 2) = 1) Or (c = 0) Then
            Return ""   'error - strHex must be even number of chars and not empty
        End If

        For i As Integer = 0 To (c \ 2) - 1
            strHexPair = strHex.Substring(i * 2, 2)
            If i = 0 Then
                intLsbSum = Convert.ToByte(strHexPair, 16)
            Else
                intLsbSum = (intLsbSum + Convert.ToByte(strHexPair, 16)) Mod 256
            End If
        Next

        'return two's complement as hex pair string
        CheckSum = Val2HexPair(((intLsbSum Xor 255) + 1) And &HFF)

    End Function

    Private Function Val2HexPair(intVal As Integer) As String
        Return Strings.Right("0" & Conversion.Hex(intVal), 2)
    End Function

    Private Function FilenameOnly(strFilename As String) As String

        Dim bs As Integer = InStrRev(strFilename, "\")
        If bs = 0 Then
            Return strFilename
        Else
            Return Strings.Mid(strFilename, bs + 1)
        End If

    End Function

    Private Sub GuideToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles GuideToolStripMenuItem.Click
        MenuHelpGuide()
    End Sub

    Private Sub AboutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem.Click
        Dim strMsg As String = "GM Arts EEP is a settings file editor for GM Arts TB-12 firmware." & vbLf & vbLf
        strMsg &= "This is GM Arts MFC TB-12 Editor version " & My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & IIf(IS_BETA, " Beta", "") & vbLf & vbLf
        strMsg &= "It saves .EEP settings files in version " & Data(0).ToString & "." & Data(1).ToString & " which are " & vbLf
        strMsg &= "compatible with GM Arts TB-12 versions 1.1x, 1.5x and 2.1x"
        MessageBox.Show(strMsg, My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub MenuHelpGuide()

        Dim strTabPage As String = ""

        Select Case tabMain.SelectedIndex
            Case 0
                strTabPage = "#midi_settings"
            Case 1
                strTabPage = "#patch_settings"
            Case 2
                strTabPage = "#bank_settings"
            Case 3
                strTabPage = "#effect_settings"
            Case 4
                strTabPage = "#pedal_settings"
            Case 5
                strTabPage = "#custom_settings"
            Case 6
                strTabPage = "#other_settings"
        End Select

        'see https://code.logos.com/blog/2008/01/using_processstart_to_link_to.html
        Try
            Cursor = Cursors.AppStarting
            Process.Start("http://bjdevices.com/wiki/doku.php?id=gm_arts_tb-12_v1" & strTabPage)
        Catch ex As Exception

        Finally
            Cursor = Cursors.Default
        End Try

    End Sub

    Private Sub frmMain_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        If e.CloseReason = CloseReason.UserClosing Then
            If Not SaveIfDirty() Then
                e.Cancel = True
            End If
        End If
    End Sub

    Private Function SaveIfDirty() As Boolean
        'returns true unless data has chnaged and user clicks cancel on prompt to save: yes/no/cancel
        If bSettingsDirty Then
            Select Case MessageBox.Show("Save current settings first?", My.Application.Info.ProductName, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
                Case DialogResult.Yes
                    MenuFileSaveAs()
                    Return True
                Case DialogResult.Cancel
                    Return False
                Case Else 'no
                    Return True
            End Select
        Else
            Return True
        End If
    End Function

#End Region

#Region "Spin control fixes"

    Private Sub spnMidiChan_KeyDown(sender As Object, e As KeyEventArgs) Handles _
        spnMidiChan.KeyDown, spnMidiMSB.KeyDown, spnMidiLSB.KeyDown, spnMidiPC.KeyDown, spnWaitAfterPC.KeyDown,
        spnEffectCCaNum.KeyDown, spnEffectCCaOff.KeyDown, spnEffectCCaOn.KeyDown,
        spnEffectCCbNum.KeyDown, spnEffectCCbOff.KeyDown, spnEffectCCbOn.KeyDown,
        spnPedalCcNum.KeyDown, spnPedalSendCcAfterPC.KeyDown, spnPedalDeadToe.KeyDown, spnPedalDeadHeel.KeyDown, spnPedalCcDisable.KeyDown,
        spnCustomCcNum.KeyDown, spnCustomOff.KeyDown, spnCustom1.KeyDown, spnCustom2.KeyDown, spnCustom3.KeyDown, spnCustom4.KeyDown, spnCustom5.KeyDown, spnCustom6.KeyDown

        ' mute Enter key
        If e.KeyCode = Keys.Enter Then
            e.SuppressKeyPress = True
        End If

        'would like to also mute beep for valid menu shortcuts

    End Sub

    Private Sub spnMidiChan_KeyUp(sender As Object, e As KeyEventArgs) Handles _
        spnMidiChan.KeyUp, spnMidiMSB.KeyUp, spnMidiLSB.KeyUp, spnMidiPC.KeyUp, spnWaitAfterPC.KeyUp,
        spnEffectCCaNum.KeyUp, spnEffectCCaOff.KeyUp, spnEffectCCaOn.KeyUp,
        spnEffectCCbNum.KeyUp, spnEffectCCbOff.KeyUp, spnEffectCCbOn.KeyUp,
        spnPedalCcNum.KeyUp, spnPedalSendCcAfterPC.KeyUp, spnPedalDeadToe.KeyUp, spnPedalDeadHeel.KeyUp, spnPedalCcDisable.KeyUp,
        spnCustomCcNum.KeyUp, spnCustomOff.KeyUp, spnCustom1.KeyUp, spnCustom2.KeyUp, spnCustom3.KeyUp, spnCustom4.KeyUp, spnCustom5.KeyUp, spnCustom6.KeyUp
        ' force numeric entered changes in spin conrtrols to trigger a .ValueChanged event with the control's focus event
        If IsNumeric(e.KeyValue) Then sender.Focus()
    End Sub


#End Region

End Class

